VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.UserControl axGrid 
   ClientHeight    =   2250
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3615
   ScaleHeight     =   2250
   ScaleWidth      =   3615
   ToolboxBitmap   =   "axGrid.ctx":0000
   Begin axGridControl.axGridButton cmdLookup 
      Height          =   220
      Left            =   2520
      Top             =   1560
      Visible         =   0   'False
      Width           =   240
      _ExtentX        =   423
      _ExtentY        =   397
      Picture         =   "axGrid.ctx":0312
      Style           =   1
   End
   Begin VB.ListBox List1 
      Appearance      =   0  'Flat
      Height          =   420
      Left            =   2340
      TabIndex        =   3
      Top             =   945
      Visible         =   0   'False
      Width           =   915
   End
   Begin VB.Frame fraGrid 
      BorderStyle     =   0  'None
      Height          =   330
      Left            =   90
      TabIndex        =   2
      Top             =   1350
      Visible         =   0   'False
      Width           =   1905
      Begin axGridControl.axGridButton btnGrid 
         Height          =   330
         Index           =   1
         Left            =   360
         Top             =   0
         Width           =   330
         _ExtentX        =   582
         _ExtentY        =   582
         Picture         =   "axGrid.ctx":079C
      End
      Begin axGridControl.axGridButton btnGrid 
         Height          =   330
         Index           =   0
         Left            =   0
         Top             =   0
         Width           =   330
         _ExtentX        =   582
         _ExtentY        =   582
         Picture         =   "axGrid.ctx":08AE
      End
   End
   Begin VB.TextBox Text1 
      Appearance      =   0  'Flat
      BorderStyle     =   0  'None
      Height          =   330
      Left            =   2340
      TabIndex        =   1
      Text            =   "Text1"
      Top             =   480
      Visible         =   0   'False
      Width           =   1140
   End
   Begin MSFlexGridLib.MSFlexGrid flxGrid 
      Height          =   1140
      Left            =   135
      TabIndex        =   0
      Top             =   135
      Width           =   1905
      _ExtentX        =   3360
      _ExtentY        =   2011
      _Version        =   65541
   End
End
Attribute VB_Name = "axGrid"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Event EnterCell() 'MappingInfo=flxGrid,flxGrid,-1,EnterCell
Attribute EnterCell.VB_Description = "Fired before the cursor enters a cell."
Event LeaveCell() 'MappingInfo=flxGrid,flxGrid,-1,LeaveCell
Attribute LeaveCell.VB_Description = "Fired after the cursor leaves a cell."
Event RowColChange() 'MappingInfo=flxGrid,flxGrid,-1,RowColChange
Attribute RowColChange.VB_Description = "Fired when the current cell changes."
Event SelChange() 'MappingInfo=flxGrid,flxGrid,-1,SelChange
Attribute SelChange.VB_Description = "Fired when the selected range of cells changes."
'Event Declarations:
Event Click() 'MappingInfo=flxGrid,flxGrid,-1,Click
Attribute Click.VB_Description = "Fired when the user presses and releases the mouse button over the control."
Event Compare(Row1 As Long, Row2 As Long, Cmp As Integer) 'MappingInfo=flxGrid,flxGrid,-1,Compare
Attribute Compare.VB_Description = "Fired during custom sorts to compare two rows."
Event KeyDown(KeyCode As Integer, Shift As Integer) 'MappingInfo=flxGrid,flxGrid,-1,KeyDown
Attribute KeyDown.VB_Description = "Fired when the user pushes a key."
Event KeyPress(KeyAscii As Integer) 'MappingInfo=flxGrid,flxGrid,-1,KeyPress
Attribute KeyPress.VB_Description = "Fired when the user presses a key."
Event KeyUp(KeyCode As Integer, Shift As Integer) 'MappingInfo=flxGrid,flxGrid,-1,KeyUp
Attribute KeyUp.VB_Description = "Fired when the user releases a key."
Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single) 'MappingInfo=flxGrid,flxGrid,-1,MouseDown
Attribute MouseDown.VB_Description = "Fired when the user presses a mouse button over the control."
Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single) 'MappingInfo=flxGrid,flxGrid,-1,MouseMove
Attribute MouseMove.VB_Description = "Fired when the user moves the mouse over the control."
Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single) 'MappingInfo=flxGrid,flxGrid,-1,MouseUp
Attribute MouseUp.VB_Description = "Fired when the user releases a mouse button over the control."
Event Scroll() 'MappingInfo=flxGrid,flxGrid,-1,Scroll
Attribute Scroll.VB_Description = "Fired when the TopRow or LeftCol properties change."
Event BeforeEdit(Row As Integer, Col As Integer, Cancel As Boolean)
Event AfterEdit(Row As Integer, Col As Integer, NewValue As String)
Event BeforeAddRow(Cancel As Boolean)
Event AfterAddRow(Row As Integer)
Event BeforeDeleteRow(Row As Integer, Cancel As Boolean)
Event AfterDeleteRow(Row As Integer)

'Default Property Values:
Const m_def_AddBtnTooltip = ""
Const m_def_DeleteBtnTooltip = ""
Const m_def_ShiftOnDelete = True
Const m_def_ShowButtons = True
Const m_def_BorderStyle = 1

'Property Variables:
Private m_AddBtnTooltip As String
Private m_DeleteBtnTooltip As String
Private m_ShiftOnDelete As Boolean
Private m_ShowButtons As Boolean
Private m_ButtonBorderStyle As Integer

Private m_LookupValues As New Collection

Public Enum AxBorderStyles
    [No Border] = 0
    [Thin Raised] = 1
    [Thick Raised] = 2
    [Thin Inset] = 3
    [Thick Inset] = 4
    [Etched] = 5
    [Bump] = 6
End Enum

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,Appearance
Public Property Get Appearance() As AppearanceSettings
Attribute Appearance.VB_Description = "Returns/sets whether a control should be painted with 3-D effects."
    Appearance = flxGrid.Appearance
End Property

Public Property Let Appearance(ByVal New_Appearance As AppearanceSettings)
    flxGrid.Appearance() = New_Appearance
    PropertyChanged "Appearance"
End Property

Private Sub btnGrid_Click(Index As Integer)
    Dim i As Integer
    Dim bCancel As Boolean
  Select Case Index
  Case 0
    'add row
    bCancel = False
    RaiseEvent BeforeAddRow(bCancel)
    If Not bCancel Then
        flxGrid.Rows = flxGrid.Rows + 1
        RaiseEvent AfterAddRow(flxGrid.Rows - 1)
    End If
  Case 1
    'delete row
    bCancel = False
    i = flxGrid.Row
    If i > flxGrid.FixedRows - 1 And flxGrid.Rows > flxGrid.FixedRows + 1 And i < flxGrid.Rows Then
        RaiseEvent BeforeDeleteRow(i, bCancel)
        If Not bCancel Then
            If m_ShiftOnDelete Then
                flxGrid.RemoveItem i
            Else
                flxGrid.Rows = flxGrid.Rows - 1
            End If
            RaiseEvent AfterDeleteRow(i)
        End If
    End If
  End Select
End Sub

Public Sub ShiftRows(ByVal Row As Long)
    Dim i As Long
    Dim ic As Long
    For i = Row To flxGrid.Rows - 2
        For ic = 0 To flxGrid.Cols - 1
            flxGrid.TextMatrix(i, ic) = flxGrid.TextMatrix(i + 1, ic)
        Next ic
    Next i
End Sub


Private Sub cmdLookup_Click()
     GridEdit Asc(" ")
End Sub

Private Sub List1_DblClick()
         flxGrid.SetFocus
End Sub

Private Sub List1_KeyDown(KeyCode As Integer, Shift As Integer)
   Select Case KeyCode
      Case vbKeyEscape
         List1.Visible = False
         flxGrid.SetFocus
      Case vbKeyReturn
         flxGrid.SetFocus
   End Select
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_ShowButtons = m_def_ShowButtons
    m_ShiftOnDelete = m_def_ShiftOnDelete
    m_AddBtnTooltip = m_def_AddBtnTooltip
    m_DeleteBtnTooltip = m_def_DeleteBtnTooltip
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
Dim totcnt As Integer
Dim Index As Integer
Dim pCol As Integer, pVal As String

    flxGrid.Appearance = PropBag.ReadProperty("Appearance", 1)
    flxGrid.AllowBigSelection = PropBag.ReadProperty("AllowBigSelection", True)
    flxGrid.AllowUserResizing = PropBag.ReadProperty("AllowUserResizing", 0)
    flxGrid.BackColor = PropBag.ReadProperty("BackColor", &H80000005)
    flxGrid.BackColorBkg = PropBag.ReadProperty("BackColorBkg", 8421504)
    flxGrid.BackColorFixed = PropBag.ReadProperty("BackColorFixed", 2147483663#)
    flxGrid.BackColorSel = PropBag.ReadProperty("BackColorSel", 2147483661#)
    flxGrid.Cols = PropBag.ReadProperty("Cols", 2)
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    flxGrid.ForeColor = PropBag.ReadProperty("ForeColor", &H80000008)
    flxGrid.ForeColorFixed = PropBag.ReadProperty("ForeColorFixed", 2147483666#)
    flxGrid.ForeColorSel = PropBag.ReadProperty("ForeColorSel", 2147483662#)
    flxGrid.GridColor = PropBag.ReadProperty("GridColor", 12632256)
    flxGrid.GridColorFixed = PropBag.ReadProperty("GridColorFixed", 0)
    flxGrid.GridLines = PropBag.ReadProperty("GridLines", 1)
    flxGrid.GridLinesFixed = PropBag.ReadProperty("GridLinesFixed", 2)
    flxGrid.GridLineWidth = PropBag.ReadProperty("GridLineWidth", 1)
    flxGrid.HighLight = PropBag.ReadProperty("HighLight", 1)
    flxGrid.Rows = PropBag.ReadProperty("Rows", 2)
    'flxGrid.RowSel = PropBag.ReadProperty("RowSel", 0)
    flxGrid.ScrollBars = PropBag.ReadProperty("ScrollBars", 3)
    flxGrid.ScrollTrack = PropBag.ReadProperty("ScrollTrack", False)
    flxGrid.SelectionMode = PropBag.ReadProperty("SelectionMode", 0)
    Set Font = PropBag.ReadProperty("Font", Ambient.Font)
    flxGrid.FormatString = PropBag.ReadProperty("FormatString", "")
    flxGrid.BorderStyle = PropBag.ReadProperty("BorderStyle", 1)
    flxGrid.FillStyle = PropBag.ReadProperty("FillStyle", 0)
    flxGrid.FixedCols = PropBag.ReadProperty("FixedCols", 1)
    flxGrid.FixedRows = PropBag.ReadProperty("FixedRows", 1)
    flxGrid.FocusRect = PropBag.ReadProperty("FocusRect", 1)
    Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    flxGrid.MousePointer = PropBag.ReadProperty("MousePointer", 0)
    flxGrid.PictureType = PropBag.ReadProperty("PictureType", 0)
    flxGrid.Redraw = PropBag.ReadProperty("Redraw", True)
    flxGrid.RightToLeft = PropBag.ReadProperty("RightToLeft", False)
    flxGrid.TextStyle = PropBag.ReadProperty("TextStyle", 0)
    flxGrid.TextStyleFixed = PropBag.ReadProperty("TextStyleFixed", 0)
    flxGrid.WordWrap = PropBag.ReadProperty("WordWrap", False)
    flxGrid.Col = PropBag.ReadProperty("Col", 0)
   For Index = 0 To flxGrid.Cols - 1
     flxGrid.ColAlignment(Index) = PropBag.ReadProperty("ColAlignment" & Index, 0)
   Next
    m_ShowButtons = PropBag.ReadProperty("ShowButtons", m_def_ShowButtons)
    m_ShiftOnDelete = PropBag.ReadProperty("ShiftOnDelete", m_def_ShiftOnDelete)
    m_AddBtnTooltip = PropBag.ReadProperty("AddBtnTooltip", m_def_AddBtnTooltip)
    btnGrid(0).ToolTipText = m_AddBtnTooltip
    m_DeleteBtnTooltip = PropBag.ReadProperty("DeleteBtnTooltip", m_def_DeleteBtnTooltip)
    btnGrid(1).ToolTipText = m_DeleteBtnTooltip
    ButtonBorderStyle = PropBag.ReadProperty("ButtonBorderStyle", m_def_BorderStyle)

    totcnt = PropBag.ReadProperty("Count", 0)
    For Index = 1 To totcnt
      pCol = PropBag.ReadProperty("Column" & Index)
      pVal = PropBag.ReadProperty("Value" & Index)
      AddLookup pCol, pVal
    Next
End Sub

Private Sub UserControl_Resize()

      flxGrid.Top = 0: flxGrid.Left = 0
      flxGrid.Width = UserControl.Width

    If m_ShowButtons Then
      fraGrid.Visible = True
      flxGrid.Height = UserControl.Height - fraGrid.Height - 80
      fraGrid.Move 40, flxGrid.Height + 35, UserControl.Width - 70
      
    Else
      fraGrid.Visible = False
      flxGrid.Height = UserControl.Height
    End If

  UserControl.Cls
  UserControl_Paint
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
Dim Index As Integer

    Call PropBag.WriteProperty("Appearance", flxGrid.Appearance, 1)
    Call PropBag.WriteProperty("AllowBigSelection", flxGrid.AllowBigSelection, True)
    Call PropBag.WriteProperty("AllowUserResizing", flxGrid.AllowUserResizing, 0)
    Call PropBag.WriteProperty("BackColor", flxGrid.BackColor, &H80000005)
    Call PropBag.WriteProperty("BackColorBkg", flxGrid.BackColorBkg, 8421504)
    Call PropBag.WriteProperty("BackColorFixed", flxGrid.BackColorFixed, 2147483663#)
    Call PropBag.WriteProperty("BackColorSel", flxGrid.BackColorSel, 2147483661#)
    Call PropBag.WriteProperty("Cols", flxGrid.Cols, 2)
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("ForeColor", flxGrid.ForeColor, &H80000008)
    Call PropBag.WriteProperty("ForeColorFixed", flxGrid.ForeColorFixed, 2147483666#)
    Call PropBag.WriteProperty("ForeColorSel", flxGrid.ForeColorSel, 2147483662#)
    Call PropBag.WriteProperty("GridColor", flxGrid.GridColor, 12632256)
    Call PropBag.WriteProperty("GridColorFixed", flxGrid.GridColorFixed, 0)
    Call PropBag.WriteProperty("GridLines", flxGrid.GridLines, 1)
    Call PropBag.WriteProperty("GridLinesFixed", flxGrid.GridLinesFixed, 2)
    Call PropBag.WriteProperty("GridLineWidth", flxGrid.GridLineWidth, 1)
    Call PropBag.WriteProperty("HighLight", flxGrid.HighLight, 1)
    Call PropBag.WriteProperty("Rows", flxGrid.Rows, 2)
    'Call PropBag.WriteProperty("RowSel", flxGrid.RowSel, 0)
    Call PropBag.WriteProperty("ScrollBars", flxGrid.ScrollBars, 3)
    Call PropBag.WriteProperty("ScrollTrack", flxGrid.ScrollTrack, False)
    Call PropBag.WriteProperty("SelectionMode", flxGrid.SelectionMode, 0)
    Call PropBag.WriteProperty("Font", Font, Ambient.Font)
    Call PropBag.WriteProperty("FormatString", flxGrid.FormatString, "")
    Call PropBag.WriteProperty("BorderStyle", flxGrid.BorderStyle, 1)
    Call PropBag.WriteProperty("FillStyle", flxGrid.FillStyle, 0)
    Call PropBag.WriteProperty("FixedCols", flxGrid.FixedCols, 1)
    Call PropBag.WriteProperty("FixedRows", flxGrid.FixedRows, 1)
    Call PropBag.WriteProperty("FocusRect", flxGrid.FocusRect, 1)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call PropBag.WriteProperty("MousePointer", flxGrid.MousePointer, 0)
    Call PropBag.WriteProperty("PictureType", flxGrid.PictureType, 0)
    Call PropBag.WriteProperty("Redraw", flxGrid.Redraw, True)
    Call PropBag.WriteProperty("RightToLeft", flxGrid.RightToLeft, False)
    Call PropBag.WriteProperty("TextStyle", flxGrid.TextStyle, 0)
    Call PropBag.WriteProperty("TextStyleFixed", flxGrid.TextStyleFixed, 0)
    Call PropBag.WriteProperty("WordWrap", flxGrid.WordWrap, False)
    Call PropBag.WriteProperty("Row", flxGrid.Row, 0)
    Call PropBag.WriteProperty("ShowButtons", m_ShowButtons, m_def_ShowButtons)
    Call PropBag.WriteProperty("ShiftOnDelete", m_ShiftOnDelete, m_def_ShiftOnDelete)
    Call PropBag.WriteProperty("AddBtnTooltip", m_AddBtnTooltip, m_def_AddBtnTooltip)
    Call PropBag.WriteProperty("DeleteBtnTooltip", m_DeleteBtnTooltip, m_def_DeleteBtnTooltip)
    Call PropBag.WriteProperty("ButtonBorderStyle", m_ButtonBorderStyle, m_def_BorderStyle)

    If Not UserControl.Ambient.UserMode Then
      Call PropBag.WriteProperty("Count", m_LookupValues.Count, 0)
      For Index = 1 To m_LookupValues.Count
        Call PropBag.WriteProperty("Column" & Index, m_LookupValues(Index).Column)
        Call PropBag.WriteProperty("Value" & Index, m_LookupValues(Index).Value)
      Next
    End If
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,AddItem
Public Sub AddItem(Item As String, Optional Index As Variant)
Attribute AddItem.VB_Description = "Adds a new row to a FlexGrid control at run time."
    If IsMissing(Index) Then
      flxGrid.AddItem Item
    Else
      flxGrid.AddItem Item, Index
    End If
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,AllowBigSelection
Public Property Get AllowBigSelection() As Boolean
Attribute AllowBigSelection.VB_Description = "Returns/sets whether clicking on a column or row header should cause the entire column or row to be selected."
    AllowBigSelection = flxGrid.AllowBigSelection
End Property

Public Property Let AllowBigSelection(ByVal New_AllowBigSelection As Boolean)
    flxGrid.AllowBigSelection() = New_AllowBigSelection
    PropertyChanged "AllowBigSelection"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,AllowUserResizing
Public Property Get AllowUserResizing() As AllowUserResizeSettings
Attribute AllowUserResizing.VB_Description = "Returns/sets whether the user should be allowed to resize rows and columns with the mouse."
    AllowUserResizing = flxGrid.AllowUserResizing
End Property

Public Property Let AllowUserResizing(ByVal New_AllowUserResizing As AllowUserResizeSettings)
    flxGrid.AllowUserResizing() = New_AllowUserResizing
    PropertyChanged "AllowUserResizing"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color of various elements of the FlexGrid."
    BackColor = flxGrid.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    flxGrid.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,BackColorBkg
Public Property Get BackColorBkg() As OLE_COLOR
Attribute BackColorBkg.VB_Description = "Returns/sets the background color of various elements of the FlexGrid."
    BackColorBkg = flxGrid.BackColorBkg
End Property

Public Property Let BackColorBkg(ByVal New_BackColorBkg As OLE_COLOR)
    flxGrid.BackColorBkg() = New_BackColorBkg
    PropertyChanged "BackColorBkg"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,BackColorFixed
Public Property Get BackColorFixed() As OLE_COLOR
Attribute BackColorFixed.VB_Description = "Returns/sets the background color of various elements of the FlexGrid."
Attribute BackColorFixed.VB_UserMemId = -501
    BackColorFixed = flxGrid.BackColorFixed
End Property

Public Property Let BackColorFixed(ByVal New_BackColorFixed As OLE_COLOR)
    flxGrid.BackColorFixed() = New_BackColorFixed
    PropertyChanged "BackColorFixed"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,BackColorSel
Public Property Get BackColorSel() As OLE_COLOR
Attribute BackColorSel.VB_Description = "Returns/sets the background color of various elements of the FlexGrid."
    BackColorSel = flxGrid.BackColorSel
End Property

Public Property Let BackColorSel(ByVal New_BackColorSel As OLE_COLOR)
    flxGrid.BackColorSel() = New_BackColorSel
    PropertyChanged "BackColorSel"
End Property


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,Cols
Public Property Get Cols() As Long
Attribute Cols.VB_Description = "Determines the total number of columns or rows in a FlexGrid."
    Cols = flxGrid.Cols
End Property

Public Property Let Cols(ByVal New_Cols As Long)
    flxGrid.Cols() = New_Cols
    PropertyChanged "Cols"
End Property


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,DataSource
Public Property Get DataSource() As IRowCursor
Attribute DataSource.VB_Description = "Returns/sets the data source for the control."
Attribute DataSource.VB_MemberFlags = "4"
    Set DataSource = flxGrid.DataSource
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property

Private Sub flxGrid_EnterCell()
    ShowLookup
    RaiseEvent EnterCell
End Sub

Private Sub ShowLookup()
    If ColHasLookup(flxGrid.Col) Then
'   MODIFIED BY GMG : 6/5/98
'          cmdLookup.Left = flxGrid.CellLeft + flxGrid.CellWidth - cmdLookup.Width
'          cmdLookup.Top = flxGrid.CellTop
'          cmdLookup.Height = flxGrid.CellHeight
          
          cmdLookup.Move flxGrid.CellLeft + flxGrid.CellWidth - cmdLookup.Width - 20, flxGrid.CellTop, cmdLookup.Width, flxGrid.CellHeight - 30
          cmdLookup.Visible = True
    Else
            cmdLookup.Visible = False
    End If

End Sub

Private Sub flxGrid_DblClick()
   If flxGrid.Col >= 0 And flxGrid.Row >= 0 Then
     GridEdit Asc(" ")
   End If
End Sub

Private Sub flxGrid_KeyPress(KeyAscii As Integer)
   RaiseEvent KeyPress(KeyAscii)
   If flxGrid.Col >= 0 And flxGrid.Row >= 0 Then
     GridEdit KeyAscii
   End If
End Sub
'
Sub GridEdit(KeyAscii As Integer)

   Dim CancelEdit As Boolean
   CancelEdit = False
   
   RaiseEvent BeforeEdit(flxGrid.Row, flxGrid.Col, CancelEdit)
   If Not CancelEdit Then
   
       If ColHasLookup(flxGrid.Col) Then
            If Not List1.Visible Then
                FillCombo (flxGrid.Col)
                List1.FontName = flxGrid.FontName
                List1.FontSize = flxGrid.FontSize
                
                'position the combo box
                List1.Left = flxGrid.CellLeft + flxGrid.Left
                List1.Top = flxGrid.CellTop + flxGrid.Top + flxGrid.CellHeight
                List1.Width = flxGrid.CellWidth         '<-- Need to check for scrollbar
                List1.Height = flxGrid.CellHeight * 4      '                   in the grid!
                List1.Visible = True
                List1.SetFocus
            Else
                'need to hide list
                flxGrid.SetFocus
                List1.Visible = False
            End If
       
       Else
       'use correct font
       Text1.FontName = flxGrid.FontName
       Text1.FontSize = flxGrid.FontSize
       Select Case KeyAscii
          Case 0 To Asc(" ")
             Text1 = flxGrid
             Text1.SelStart = 1000
          Case Else
             Text1 = Chr(KeyAscii)
             Text1.SelStart = 1
       End Select
    
       'position the edit box
       Text1.Left = flxGrid.CellLeft + flxGrid.Left
       Text1.Top = flxGrid.CellTop + flxGrid.Top
       Text1.Width = flxGrid.CellWidth - 10         '<-- Need to check for scrollbar
       Text1.Height = flxGrid.CellHeight - 10       '                   in the grid!
       Text1.Visible = True
       Text1.SetFocus
       End If
          
   End If
End Sub

Private Sub FlxGrid_LeaveCell()
   If Text1.Visible Then
      flxGrid = Text1
      Text1.Visible = False
      RaiseEvent AfterEdit(flxGrid.Row, flxGrid.Col, flxGrid)
   End If
   If List1.Visible Then
      flxGrid = IIf(List1.ListIndex >= 0, List1.List(List1.ListIndex), flxGrid)
      List1.Visible = False
      RaiseEvent AfterEdit(flxGrid.Row, flxGrid.Col, flxGrid)
   End If
   If cmdLookup.Visible Then cmdLookup.Visible = False
End Sub


Private Sub FlxGrid_GotFocus()
   If Text1.Visible Then
      flxGrid = Text1
      Text1.Visible = False
      RaiseEvent AfterEdit(flxGrid.Row, flxGrid.Col, flxGrid)
   End If
   If List1.Visible Then
      flxGrid = IIf(List1.ListIndex >= 0, List1.List(List1.ListIndex), flxGrid)
      List1.Visible = False
      RaiseEvent AfterEdit(flxGrid.Row, flxGrid.Col, flxGrid)
   End If
   
   'this causes cmdLookup to blink after the list
   'If cmdLookup.Visible Then cmdLookup.Visible = False
   ShowLookup
End Sub

Private Sub Text1_KeyDown(KeyCode As Integer, Shift As Integer)
   Select Case KeyCode
      Case vbKeyEscape
         Text1.Visible = False
         flxGrid.SetFocus
      Case vbKeyReturn
         flxGrid.SetFocus
      Case vbKeyDown
         flxGrid.SetFocus
         DoEvents
         If flxGrid.Row < flxGrid.Rows - 1 Then
            flxGrid.Row = flxGrid.Row + 1
         End If
      Case vbKeyUp
         flxGrid.SetFocus
         DoEvents
         If flxGrid.Row > flxGrid.FixedRows Then
            flxGrid.Row = flxGrid.Row - 1
         End If
   End Select
End Sub

Private Sub Text1_KeyPress(KeyAscii As Integer)
    'noise suppression
    If KeyAscii = vbKeyReturn Then KeyAscii = 0
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Determines the color used to draw text on each part of the FlexGrid."
    ForeColor = flxGrid.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    flxGrid.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,ForeColorFixed
Public Property Get ForeColorFixed() As OLE_COLOR
Attribute ForeColorFixed.VB_Description = "Determines the color used to draw text on each part of the FlexGrid."
    ForeColorFixed = flxGrid.ForeColorFixed
End Property

Public Property Let ForeColorFixed(ByVal New_ForeColorFixed As OLE_COLOR)
    flxGrid.ForeColorFixed() = New_ForeColorFixed
    PropertyChanged "ForeColorFixed"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,ForeColorSel
Public Property Get ForeColorSel() As OLE_COLOR
Attribute ForeColorSel.VB_Description = "Determines the color used to draw text on each part of the FlexGrid."
ForeColorSel = flxGrid.ForeColorSel
End Property

Public Property Let ForeColorSel(ByVal New_ForeColorSel As OLE_COLOR)
    flxGrid.ForeColorSel() = New_ForeColorSel
    PropertyChanged "ForeColorSel"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,GridColor
Public Property Get GridColor() As OLE_COLOR
Attribute GridColor.VB_Description = "Returns/sets the color used to draw the lines between FlexGrid cells."
    GridColor = flxGrid.GridColor
End Property

Public Property Let GridColor(ByVal New_GridColor As OLE_COLOR)
    flxGrid.GridColor() = New_GridColor
    PropertyChanged "GridColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,GridColorFixed
Public Property Get GridColorFixed() As OLE_COLOR
Attribute GridColorFixed.VB_Description = "Returns/sets the color used to draw the lines between FlexGrid cells."
    GridColorFixed = flxGrid.GridColorFixed
End Property

Public Property Let GridColorFixed(ByVal New_GridColorFixed As OLE_COLOR)
    flxGrid.GridColorFixed() = New_GridColorFixed
    PropertyChanged "GridColorFixed"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,GridLines
Public Property Get GridLines() As GridLineSettings
Attribute GridLines.VB_Description = "Returns/sets the type of lines that should be drawn between cells."
    GridLines = flxGrid.GridLines
End Property

Public Property Let GridLines(ByVal New_GridLines As GridLineSettings)
    flxGrid.GridLines() = New_GridLines
    PropertyChanged "GridLines"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,GridLinesFixed
Public Property Get GridLinesFixed() As GridLineSettings
Attribute GridLinesFixed.VB_Description = "Returns/sets the type of lines that should be drawn between cells."
    GridLinesFixed = flxGrid.GridLinesFixed
End Property

Public Property Let GridLinesFixed(ByVal New_GridLinesFixed As GridLineSettings)
    flxGrid.GridLinesFixed() = New_GridLinesFixed
    PropertyChanged "GridLinesFixed"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,GridLineWidth
Public Property Get GridLineWidth() As Integer
Attribute GridLineWidth.VB_Description = "Returns/sets the width in Pixels of the gridlines for the control."
    GridLineWidth = flxGrid.GridLineWidth
End Property

Public Property Let GridLineWidth(ByVal New_GridLineWidth As Integer)
    flxGrid.GridLineWidth() = New_GridLineWidth
    PropertyChanged "GridLineWidth"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,HighLight
Public Property Get HighLight() As HighLightSettings
Attribute HighLight.VB_Description = "Returns/sets whether selected cells appear highlighted."
    HighLight = flxGrid.HighLight
End Property

Public Property Let HighLight(ByVal New_HighLight As HighLightSettings)
    flxGrid.HighLight() = New_HighLight
    PropertyChanged "HighLight"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,MergeCol
Public Property Get MergeCol(ByVal Index As Long) As Boolean
Attribute MergeCol.VB_Description = "Returns/sets which rows (columns) should have their contents merged when the MergeCells property is set to a value other than 0 - Never."
    MergeCol = flxGrid.MergeCol(Index)
End Property

Public Property Let MergeCol(ByVal Index As Long, ByVal New_MergeCol As Boolean)
    flxGrid.MergeCol(Index) = New_MergeCol
    PropertyChanged "MergeCol"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,MergeRow
Public Property Get MergeRow(ByVal Index As Long) As Boolean
Attribute MergeRow.VB_Description = "Returns/sets which rows (columns) should have their contents merged when the MergeCells property is set to a value other than 0 - Never."
    MergeRow = flxGrid.MergeRow(Index)
End Property

Public Property Let MergeRow(ByVal Index As Long, ByVal New_MergeRow As Boolean)
    flxGrid.MergeRow(Index) = New_MergeRow
    PropertyChanged "MergeRow"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,RemoveItem
Public Sub RemoveItem(ByVal Index As Long)
Attribute RemoveItem.VB_Description = "Removes a row from a FlexGrid control at run time"
    flxGrid.RemoveItem Index
End Sub

Private Sub flxGrid_RowColChange()
    RaiseEvent RowColChange
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,RowData
Public Property Get RowData(ByVal Index As Long) As Long
Attribute RowData.VB_Description = "Array of long integer values with one item for each row (RowData) and for each column (ColData) of the FlexGrid. Not available at design time."
    RowData = flxGrid.RowData(Index)
End Property

Public Property Let RowData(ByVal Index As Long, ByVal New_RowData As Long)
    flxGrid.RowData(Index) = New_RowData
    PropertyChanged "RowData"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,RowHeight
Public Property Get RowHeight(ByVal Index As Long) As Long
Attribute RowHeight.VB_Description = "Returns/sets the height of the specified row in Twips. Not available at design time."
    RowHeight = flxGrid.RowHeight(Index)
End Property

Public Property Let RowHeight(ByVal Index As Long, ByVal New_RowHeight As Long)
    flxGrid.RowHeight(Index) = New_RowHeight
    PropertyChanged "RowHeight"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,RowHeightMin
Public Property Get RowHeightMin() As Long
Attribute RowHeightMin.VB_Description = "Returns/sets a minimum row height for the entire control, in Twips."
    RowHeightMin = flxGrid.RowHeightMin
End Property

Public Property Let RowHeightMin(ByVal New_RowHeightMin As Long)
    flxGrid.RowHeightMin() = New_RowHeightMin
    PropertyChanged "RowHeightMin"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,RowIsVisible
Public Property Get RowIsVisible(ByVal Index As Long) As Boolean
Attribute RowIsVisible.VB_Description = "Returns True if the specified row is visible."
    RowIsVisible = flxGrid.RowIsVisible(Index)
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,RowPos
Public Property Get RowPos(ByVal Index As Long) As Long
Attribute RowPos.VB_Description = "Returns the distance in Twips between the upper-left corner of the control and the upper-left corner of a specified row."
    RowPos = flxGrid.RowPos(Index)
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,RowPosition
'Public Property Get RowPosition(Index As Long) As Long
'    RowPosition = flxGrid.RowPosition(Index)
'End Property

Public Property Let RowPosition(ByVal Index As Long, ByVal New_RowPosition As Long)
Attribute RowPosition.VB_Description = "Returns the distance in Twips between the upper-left corner of the control and the upper-left corner of a specified row."
    flxGrid.RowPosition(Index) = New_RowPosition
    PropertyChanged "RowPosition"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,Rows
Public Property Get Rows() As Long
Attribute Rows.VB_Description = "Determines the total number of columns or rows in a FlexGrid."
    Rows = flxGrid.Rows
End Property

Public Property Let Rows(ByVal New_Rows As Long)
    flxGrid.Rows() = New_Rows
    PropertyChanged "Rows"
End Property
'
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,ScrollBars
Public Property Get ScrollBars() As ScrollBarsSettings
Attribute ScrollBars.VB_Description = "Returns/sets whether a FlexGrid has horizontal or vertical scroll bars."
    ScrollBars = flxGrid.ScrollBars
End Property

Public Property Let ScrollBars(ByVal New_ScrollBars As ScrollBarsSettings)
    flxGrid.ScrollBars() = New_ScrollBars
    PropertyChanged "ScrollBars"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,ScrollTrack
Public Property Get ScrollTrack() As Boolean
Attribute ScrollTrack.VB_Description = "Returns/sets whether FlexGrid should scroll its contents while the user moves the scroll box along the scroll bars."
    ScrollTrack = flxGrid.ScrollTrack
End Property

Public Property Let ScrollTrack(ByVal New_ScrollTrack As Boolean)
    flxGrid.ScrollTrack() = New_ScrollTrack
    PropertyChanged "ScrollTrack"
End Property

Private Sub flxGrid_SelChange()
    RaiseEvent SelChange
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,SelectionMode
Public Property Get SelectionMode() As SelectionModeSettings
Attribute SelectionMode.VB_Description = "Returns/sets whether a FlexGrid should allow regular cell selection, selection by rows, or selection by columns."
    SelectionMode = flxGrid.SelectionMode
End Property

Public Property Let SelectionMode(ByVal New_SelectionMode As SelectionModeSettings)
    flxGrid.SelectionMode() = New_SelectionMode
    PropertyChanged "SelectionMode"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns/sets the default font or the font for individual cells."
Attribute Font.VB_UserMemId = -512
    Set Font = flxGrid.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set flxGrid.Font = New_Font
    Set Text1.Font = New_Font
    PropertyChanged "Font"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,FormatString
Public Property Get FormatString() As String
Attribute FormatString.VB_Description = "Allows you to set up a FlexGrid's column widths, alignments, and fixed row and column text at design time. See the help file for details."
    FormatString = flxGrid.FormatString
End Property

Public Property Let FormatString(ByVal New_FormatString As String)
    flxGrid.FormatString() = New_FormatString
    PropertyChanged "FormatString"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,BorderStyle
Public Property Get BorderStyle() As BorderStyleSettings
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
    BorderStyle = flxGrid.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As BorderStyleSettings)
    flxGrid.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,DataBindings
Public Property Get DataBindings() As DataBindings
Attribute DataBindings.VB_Description = "Returns/sets a DataBindings collection object that collects the bindable properties that are available to the developer."
Attribute DataBindings.VB_MemberFlags = "4"
    Set DataBindings = flxGrid.DataBindings
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,FillStyle
Public Property Get FillStyle() As FillStyleSettings
Attribute FillStyle.VB_Description = "Determines whether setting the Text property or one of the Cell formatting properties of a FlexGrid applies the change to all selected cells."
    FillStyle = flxGrid.FillStyle
End Property

Public Property Let FillStyle(ByVal New_FillStyle As FillStyleSettings)
    flxGrid.FillStyle() = New_FillStyle
    PropertyChanged "FillStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,FixedCols
Public Property Get FixedCols() As Long
Attribute FixedCols.VB_Description = "Returns/sets the total number of fixed (non-scrollable) columns or rows for a FlexGrid."
    FixedCols = flxGrid.FixedCols
End Property

Public Property Let FixedCols(ByVal New_FixedCols As Long)
    flxGrid.FixedCols() = New_FixedCols
    PropertyChanged "FixedCols"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,FixedRows
Public Property Get FixedRows() As Long
Attribute FixedRows.VB_Description = "Returns/sets the total number of fixed (non-scrollable) columns or rows for a FlexGrid."
    FixedRows = flxGrid.FixedRows
End Property

Public Property Let FixedRows(ByVal New_FixedRows As Long)
    flxGrid.FixedRows() = New_FixedRows
    PropertyChanged "FixedRows"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,FocusRect
Public Property Get FocusRect() As FocusRectSettings
Attribute FocusRect.VB_Description = "Determines whether the FlexGrid control should draw a focus rectangle around the current cell."
    FocusRect = flxGrid.FocusRect
End Property

Public Property Let FocusRect(ByVal New_FocusRect As FocusRectSettings)
    flxGrid.FocusRect() = New_FocusRect
    PropertyChanged "FocusRect"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,MouseIcon
Public Property Get MouseIcon() As Picture
Attribute MouseIcon.VB_Description = "Returns/sets a custom mouse icon."
    Set MouseIcon = flxGrid.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
    Set flxGrid.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,MousePointer
Public Property Get MousePointer() As MousePointerSettings
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
    MousePointer = flxGrid.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As MousePointerSettings)
    flxGrid.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,PictureType
Public Property Get PictureType() As PictureTypeSettings
Attribute PictureType.VB_Description = "Returns/sets the type of picture that should be generated by the Picture property."
    PictureType = flxGrid.PictureType
End Property

Public Property Let PictureType(ByVal New_PictureType As PictureTypeSettings)
    flxGrid.PictureType() = New_PictureType
    PropertyChanged "PictureType"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,Redraw
Public Property Get Redraw() As Boolean
Attribute Redraw.VB_Description = "Enables or disables redrawing of the FlexGrid control."
    Redraw = flxGrid.Redraw
End Property

Public Property Let Redraw(ByVal New_Redraw As Boolean)
    flxGrid.Redraw() = New_Redraw
    PropertyChanged "Redraw"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,RightToLeft
Public Property Get RightToLeft() As Boolean
Attribute RightToLeft.VB_Description = "Determines text display direction and control visual appearance on a bidirectional system."
    RightToLeft = flxGrid.RightToLeft
End Property

Public Property Let RightToLeft(ByVal New_RightToLeft As Boolean)
    flxGrid.RightToLeft() = New_RightToLeft
    PropertyChanged "RightToLeft"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,TextStyle
Public Property Get TextStyle() As TextStyleSettings
Attribute TextStyle.VB_Description = "Returns/sets 3D effects for displaying text."
    TextStyle = flxGrid.TextStyle
End Property

Public Property Let TextStyle(ByVal New_TextStyle As TextStyleSettings)
    flxGrid.TextStyle() = New_TextStyle
    PropertyChanged "TextStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,TextStyleFixed
Public Property Get TextStyleFixed() As TextStyleSettings
Attribute TextStyleFixed.VB_Description = "Returns/sets 3D effects for displaying text."
    TextStyleFixed = flxGrid.TextStyleFixed
End Property

Public Property Let TextStyleFixed(ByVal New_TextStyleFixed As TextStyleSettings)
    flxGrid.TextStyleFixed() = New_TextStyleFixed
    PropertyChanged "TextStyleFixed"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,WordWrap
Public Property Get WordWrap() As Boolean
Attribute WordWrap.VB_Description = "Returns/sets whether text within a cell should be allowed to wrap."
    WordWrap = flxGrid.WordWrap
End Property

Public Property Let WordWrap(ByVal New_WordWrap As Boolean)
    flxGrid.WordWrap() = New_WordWrap
    PropertyChanged "WordWrap"
End Property

Public Sub ShowAboutBox()
Attribute ShowAboutBox.VB_UserMemId = -552
  frmAbout.Show vbModal
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,Clear
Public Sub Clear()
Attribute Clear.VB_Description = "Clears the contents of the FlexGrid. This includes all text, pictures, and cell formatting."
    flxGrid.Clear
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,Refresh
Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a form or control."
    flxGrid.Refresh
End Sub

Private Sub flxGrid_Click()
    ShowLookup
    RaiseEvent Click
End Sub

Private Sub flxGrid_Compare(ByVal Row1 As Long, ByVal Row2 As Long, Cmp As Integer)
    RaiseEvent Compare(Row1, Row2, Cmp)
End Sub

Private Sub flxGrid_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub flxGrid_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub flxGrid_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    RaiseEvent MouseDown(Button, Shift, x, y)
End Sub

Private Sub flxGrid_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    RaiseEvent MouseMove(Button, Shift, x, y)
End Sub

Private Sub flxGrid_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    RaiseEvent MouseUp(Button, Shift, x, y)
End Sub

Private Sub flxGrid_Scroll()
   If Text1.Visible Then Text1.Visible = False
   If List1.Visible Then List1.Visible = False
   If cmdLookup.Visible Then cmdLookup.Visible = False
   RaiseEvent Scroll
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,CellAlignment
Public Property Get CellAlignment() As Integer
Attribute CellAlignment.VB_Description = "Returns/sets the alignment of data in a cell or range of selected cells. Not available at design time."
Attribute CellAlignment.VB_MemberFlags = "400"
    CellAlignment = flxGrid.CellAlignment
End Property

Public Property Let CellAlignment(ByVal New_CellAlignment As Integer)
    flxGrid.CellAlignment() = New_CellAlignment
    PropertyChanged "CellAlignment"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,CellBackColor
Public Property Get CellBackColor() As Long
Attribute CellBackColor.VB_Description = "Returns/sets the background and foreground colors of individual cells or ranges of cells."
Attribute CellBackColor.VB_MemberFlags = "400"
    CellBackColor = flxGrid.CellBackColor
End Property

Public Property Let CellBackColor(ByVal New_CellBackColor As Long)
    flxGrid.CellBackColor() = New_CellBackColor
    PropertyChanged "CellBackColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,CellForeColor
Public Property Get CellForeColor() As Long
Attribute CellForeColor.VB_Description = "Returns/sets the background and foreground colors of individual cells or ranges of cells."
Attribute CellForeColor.VB_MemberFlags = "400"
    CellForeColor = flxGrid.CellForeColor
End Property

Public Property Let CellForeColor(ByVal New_CellForeColor As Long)
    flxGrid.CellForeColor() = New_CellForeColor
    PropertyChanged "CellForeColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,CellHeight
Public Property Get CellHeight() As Long
Attribute CellHeight.VB_Description = "Returns the height of the current cell, in Twips."
Attribute CellHeight.VB_MemberFlags = "400"
    CellHeight = flxGrid.CellHeight
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,CellLeft
Public Property Get CellLeft() As Long
Attribute CellLeft.VB_Description = "Returns the left position of the current cell, in twips"
Attribute CellLeft.VB_MemberFlags = "400"
    CellLeft = flxGrid.CellLeft
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,CellPicture
Public Property Get CellPicture() As Picture
Attribute CellPicture.VB_Description = "Returns/sets an image to be displayed in the current cell or in a range of cells."
Attribute CellPicture.VB_MemberFlags = "400"
    Set CellPicture = flxGrid.CellPicture
End Property

Public Property Set CellPicture(ByVal New_CellPicture As Picture)
    Set flxGrid.CellPicture = New_CellPicture
    PropertyChanged "CellPicture"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,CellPictureAlignment
Public Property Get CellPictureAlignment() As Integer
Attribute CellPictureAlignment.VB_Description = "Returns/sets the alignment of pictures in a cell or range of selected cells. Not available at design time."
Attribute CellPictureAlignment.VB_MemberFlags = "400"
    CellPictureAlignment = flxGrid.CellPictureAlignment
End Property

Public Property Let CellPictureAlignment(ByVal New_CellPictureAlignment As Integer)
    flxGrid.CellPictureAlignment() = New_CellPictureAlignment
    PropertyChanged "CellPictureAlignment"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,CellTextStyle
Public Property Get CellTextStyle() As TextStyleSettings
Attribute CellTextStyle.VB_Description = "Returns/sets 3D effects for text on a specific cell or range of cells."
Attribute CellTextStyle.VB_MemberFlags = "400"
    CellTextStyle = flxGrid.CellTextStyle
End Property

Public Property Let CellTextStyle(ByVal New_CellTextStyle As TextStyleSettings)
    flxGrid.CellTextStyle() = New_CellTextStyle
    PropertyChanged "CellTextStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,CellTop
Public Property Get CellTop() As Long
Attribute CellTop.VB_Description = "Returns or sets the top position of the current cell, in twips"
Attribute CellTop.VB_MemberFlags = "400"
    CellTop = flxGrid.CellTop
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,CellWidth
Public Property Get CellWidth() As Long
Attribute CellWidth.VB_Description = "Returns the width of the current cell, in twips"
Attribute CellWidth.VB_MemberFlags = "400"
    CellWidth = flxGrid.CellWidth
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,Col
Public Property Get Col() As Long
Attribute Col.VB_Description = "Returns/sets the active cell in a FlexGrid. Not available at design time."
Attribute Col.VB_MemberFlags = "400"
    Col = flxGrid.Col
End Property

Public Property Let Col(ByVal New_Col As Long)
    flxGrid.Col() = New_Col
    PropertyChanged "Col"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,ColAlignment
Public Property Get ColAlignment(ByVal Index As Long) As Integer
Attribute ColAlignment.VB_Description = "Returns/sets the alignment of data in a column. Not available at design time (except indirectly through the FormatString property)."
    ColAlignment = flxGrid.ColAlignment(Index)
End Property

Public Property Let ColAlignment(ByVal Index As Long, ByVal New_ColAlignment As Integer)
    flxGrid.ColAlignment(Index) = New_ColAlignment
    PropertyChanged "ColAlignment"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,ColData
Public Property Get ColData(ByVal Index As Long) As Long
Attribute ColData.VB_Description = "Array of long integer values with one item for each row (RowData) and for each column (ColData) of the FlexGrid. Not available at design time."
    ColData = flxGrid.ColData(Index)
End Property

Public Property Let ColData(ByVal Index As Long, ByVal New_ColData As Long)
    flxGrid.ColData(Index) = New_ColData
    PropertyChanged "ColData"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,ColIsVisible
Public Property Get ColIsVisible(ByVal Index As Long) As Boolean
Attribute ColIsVisible.VB_Description = "Returns True if the specified column is visible."
    ColIsVisible = flxGrid.ColIsVisible(Index)
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,ColPos
Public Property Get ColPos(ByVal Index As Long) As Long
Attribute ColPos.VB_Description = "Returns the distance in Twips between the upper-left corner of the control and the upper-left corner of a specified column."
    ColPos = flxGrid.ColPos(Index)
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,ColPosition
'Public Property Get ColPosition(index As Long) As Long
'    ColPosition = flxGrid.ColPosition(index)
'End Property

Public Property Let ColPosition(ByVal Index As Long, ByVal New_ColPosition As Long)
Attribute ColPosition.VB_Description = "Returns the distance in Twips between the upper-left corner of the control and the upper-left corner of a specified column."
    flxGrid.ColPosition(Index) = New_ColPosition
    PropertyChanged "ColPosition"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,ColSel
Public Property Get ColSel() As Long
Attribute ColSel.VB_Description = "Determines the starting or ending row or column for a range of cells. Not available at design time."
Attribute ColSel.VB_MemberFlags = "400"
    ColSel = flxGrid.ColSel
End Property

Public Property Let ColSel(ByVal New_ColSel As Long)
    flxGrid.ColSel() = New_ColSel
    PropertyChanged "ColSel"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,ColWidth
Public Property Get ColWidth(ByVal Index As Long) As Long
Attribute ColWidth.VB_Description = "Determines the width of the specified column in Twips. Not available at design time."
    ColWidth = flxGrid.ColWidth(Index)
End Property

Public Property Let ColWidth(ByVal Index As Long, ByVal New_ColWidth As Long)
    flxGrid.ColWidth(Index) = New_ColWidth
    PropertyChanged "ColWidth"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,FixedAlignment
Public Property Get FixedAlignment(ByVal Index As Long) As Integer
Attribute FixedAlignment.VB_Description = "Returns/sets the alignment of data in the fixed cells of a column."
    FixedAlignment = flxGrid.FixedAlignment(Index)
End Property

Public Property Let FixedAlignment(ByVal Index As Long, ByVal New_FixedAlignment As Integer)
    flxGrid.FixedAlignment(Index) = New_FixedAlignment
    PropertyChanged "FixedAlignment"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,LeftCol
Public Property Get LeftCol() As Long
Attribute LeftCol.VB_Description = "Returns/sets the leftmost visible column (other than a fixed column) in the FlexGrid. Not available at design time."
Attribute LeftCol.VB_MemberFlags = "400"
    LeftCol = flxGrid.LeftCol
End Property

Public Property Let LeftCol(ByVal New_LeftCol As Long)
    flxGrid.LeftCol() = New_LeftCol
    PropertyChanged "LeftCol"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,MergeCells
Public Property Get MergeCells() As MergeCellsSettings
Attribute MergeCells.VB_Description = "Returns/sets whether cells with the same contents should be grouped in a single cell spanning multiple rows or columns."
    MergeCells = flxGrid.MergeCells
End Property

Public Property Let MergeCells(ByVal New_MergeCells As MergeCellsSettings)
    flxGrid.MergeCells() = New_MergeCells
    PropertyChanged "MergeCells"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,MouseCol
Public Property Get MouseCol() As Long
Attribute MouseCol.VB_Description = "Returns/sets over which row (column) the mouse pointer is. Not available at design time."
    MouseCol = flxGrid.MouseCol
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,MouseRow
Public Property Get MouseRow() As Long
Attribute MouseRow.VB_Description = "Returns/sets over which row (column) the mouse pointer is. Not available at design time."
    MouseRow = flxGrid.MouseRow
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,Row
Public Property Get Row() As Long
Attribute Row.VB_Description = "Returns/sets the active cell in a FlexGrid. Not available at design time."
Attribute Row.VB_MemberFlags = "400"
    Row = flxGrid.Row
End Property

Public Property Let Row(ByVal New_Row As Long)
    flxGrid.Row() = New_Row
    PropertyChanged "Row"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,RowSel
Public Property Get RowSel() As Long
Attribute RowSel.VB_Description = "Determines the starting or ending row or column for a range of cells. Not available at design time."
Attribute RowSel.VB_MemberFlags = "400"
    RowSel = flxGrid.RowSel
End Property

Public Property Let RowSel(ByVal New_RowSel As Long)
    flxGrid.RowSel() = New_RowSel
    PropertyChanged "RowSel"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,Text
Public Property Get Text() As String
Attribute Text.VB_Description = "Returns/sets the text contents of a cell or range of cells."
Attribute Text.VB_MemberFlags = "400"
    Text = flxGrid.Text
End Property

Public Property Let Text(ByVal New_Text As String)
    flxGrid.Text() = New_Text
    PropertyChanged "Text"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,TextArray
Public Property Get TextArray(Index As Long) As String
Attribute TextArray.VB_Description = "Returns/sets the text contents of an arbitrary cell (single subscript)."
    TextArray = flxGrid.TextArray(Index)
End Property

Public Property Let TextArray(Index As Long, ByVal New_TextArray As String)
    flxGrid.TextArray(Index) = New_TextArray
    PropertyChanged "TextArray"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,TextMatrix
Public Property Get TextMatrix(ByVal Row As Long, ByVal Col As Long) As String
Attribute TextMatrix.VB_Description = "Returns/sets the text contents of an arbitrary cell (row/col subscripts)."
    TextMatrix = flxGrid.TextMatrix(Row, Col)
End Property

Public Property Let TextMatrix(ByVal Row As Long, ByVal Col As Long, ByVal New_TextMatrix As String)
    flxGrid.TextMatrix(Row, Col) = New_TextMatrix
    PropertyChanged "TextMatrix"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=flxGrid,flxGrid,-1,TopRow
Public Property Get TopRow() As Long
Attribute TopRow.VB_Description = "Returns/sets the uppermost row displayed in the FlexGrid. Not available at design time."
    TopRow = flxGrid.TopRow
End Property

'Public Property Let TopRow(ByVal New_TopRow As Long)
'    flxGrid.TopRow() = New_TopRow
'    PropertyChanged "TopRow"
'End Property


Public Sub AutoSize()
Attribute AutoSize.VB_Description = "Autosize control to size of grid"
Dim i, j, lw As Double, lh As Double, gw As Double, gh As Double

  DoEvents
  gw = flxGrid.GridLineWidth * Screen.TwipsPerPixelX
  If flxGrid.Cols < 11 Then gw = gw * 2
  gh = flxGrid.GridLineWidth * Screen.TwipsPerPixelY
  lw = 36 + gw + 36
  lh = 31 + gh + 31
  For i = 0 To flxGrid.Rows - 1
    lh = lh + flxGrid.RowHeight(i) + flxGrid.GridLineWidth
  Next
  For j = 0 To flxGrid.Cols - 1
    lw = lw + flxGrid.ColWidth(j) + flxGrid.GridLineWidth
  Next
  UserControl.Width = lw
  UserControl.Height = lh
'UserControl_Resize gets automatically called by changing these
  DoEvents
End Sub

Public Sub AutoSetup(NRows As Variant, NCols As Variant, NFixedRows As Variant, NFixedCols As Variant, theFontName As Variant, theFontSize As Variant, theMSFlexGridFormatString As Variant)
Attribute AutoSetup.VB_Description = "Automatically setup grid according to passed parameters"

' Always (re)set to zero to avoid errors when fixedrows >= rows
  flxGrid.Clear
  flxGrid.FormatString = ""

  UserControl.Font.Name = theFontName
  UserControl.Font.Size = theFontSize
  Call SyncFonts
  PropertyChanged "Font"
  
  flxGrid.Rows = NRows
  PropertyChanged "Rows"
  flxGrid.Cols = NCols
  PropertyChanged "Cols"
  
  flxGrid.FixedRows = NFixedRows
  PropertyChanged "FixedRows"
  flxGrid.FixedCols = NFixedCols
  PropertyChanged "FixedCols"
  
  flxGrid.FormatString = theMSFlexGridFormatString
  PropertyChanged "FormatString"
  Text1.Text = ""
  
  Call UserControl_Resize
  flxGrid.Refresh
  
  DoEvents
End Sub


Private Sub SyncFonts()
  Set flxGrid.Font = UserControl.Font
  Set Text1.Font = UserControl.Font
  DoEvents
End Sub

Public Property Get ShowButtons() As Boolean
    ShowButtons = m_ShowButtons
End Property

Public Property Let ShowButtons(ByVal New_ShowButtons As Boolean)
    m_ShowButtons = New_ShowButtons
    PropertyChanged "ShowButtons"
    Call UserControl_Resize
End Property

Public Property Get ShiftOnDelete() As Boolean
    ShiftOnDelete = m_ShiftOnDelete
End Property

Public Property Let ShiftOnDelete(ByVal New_ShiftOnDelete As Boolean)
    m_ShiftOnDelete = New_ShiftOnDelete
    PropertyChanged "ShiftOnDelete"
End Property

Public Property Get AddBtnTooltip() As String
    AddBtnTooltip = btnGrid(0).ToolTipText
End Property

Public Property Let AddBtnTooltip(ByVal New_AddBtnTooltip As String)
    m_AddBtnTooltip = New_AddBtnTooltip
    PropertyChanged "AddBtnTooltip"
    btnGrid(0).ToolTipText = m_AddBtnTooltip
End Property

Public Property Get DeleteBtnTooltip() As String
    DeleteBtnTooltip = btnGrid(1).ToolTipText
End Property

Public Property Let DeleteBtnTooltip(ByVal New_DeleteBtnTooltip As String)
    m_DeleteBtnTooltip = New_DeleteBtnTooltip
    PropertyChanged "DeleteBtnTooltip"
    btnGrid(1).ToolTipText = m_DeleteBtnTooltip
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Ambient
Public Property Get Ambient() As AmbientProperties
Attribute Ambient.VB_MemberFlags = "400"
    Set Ambient = UserControl.Ambient
End Property

Private Sub UserControl_Paint()
    Dim di As Long
    Dim rc As RECT
    
    'draw outside border
        
    rc.Top = fraGrid.Top / Screen.TwipsPerPixelY - 2
    rc.Left = 1
    rc.Right = UserControl.Width / Screen.TwipsPerPixelX
    rc.Bottom = UserControl.Height / Screen.TwipsPerPixelY - 1
    
    Select Case m_ButtonBorderStyle
        Case [No Border]
        
        Case [Thin Raised]
            'di = GetClientRect(fraGrid.hwnd, rc)
            di = DrawEdge(UserControl.hDC, rc, BDR_RAISEDINNER, BF_TOPLEFT)
            di = DrawEdge(UserControl.hDC, rc, BDR_RAISEDOUTER, BF_BOTTOMRIGHT)
        
        Case [Thick Raised]
            'di = GetClientRect(fraGrid.hwnd, rc)
            di = DrawEdge(UserControl.hDC, rc, EDGE_RAISED, BF_TOPLEFT)
            di = DrawEdge(UserControl.hDC, rc, EDGE_RAISED, BF_BOTTOMRIGHT)
    
        Case [Thin Inset]
            'di = GetClientRect(fraGrid.hwnd, rc)
            di = DrawEdge(UserControl.hDC, rc, BDR_SUNKENINNER, BF_TOPLEFT)
            di = DrawEdge(UserControl.hDC, rc, BDR_SUNKENOUTER, BF_BOTTOMRIGHT)
        
        Case [Thick Inset]
            'di = GetClientRect(fraGrid.hwnd, rc)
            di = DrawEdge(UserControl.hDC, rc, EDGE_SUNKEN, BF_TOPLEFT)
            di = DrawEdge(UserControl.hDC, rc, EDGE_SUNKEN, BF_BOTTOMRIGHT)
        
        Case [Etched]
            'di = GetClientRect(fraGrid.hwnd, rc)
            di = DrawEdge(UserControl.hDC, rc, EDGE_ETCHED, BF_TOPLEFT)
            di = DrawEdge(UserControl.hDC, rc, EDGE_ETCHED, BF_BOTTOMRIGHT)
    
        Case [Bump]
            'di = GetClientRect(fraGrid.hwnd, rc)
            di = DrawEdge(UserControl.hDC, rc, EDGE_BUMP, BF_TOPLEFT)
            di = DrawEdge(UserControl.hDC, rc, EDGE_BUMP, BF_BOTTOMRIGHT)
            
    End Select
End Sub


Public Property Get ButtonBorderStyle() As AxBorderStyles
    ButtonBorderStyle = m_ButtonBorderStyle
End Property

Public Property Let ButtonBorderStyle(ByVal New_ButtonBorderStyle As AxBorderStyles)
    If Not (m_ButtonBorderStyle = New_ButtonBorderStyle) Then
        m_ButtonBorderStyle = New_ButtonBorderStyle
        UserControl.Cls
        UserControl_Paint
    End If
    PropertyChanged "ButtonBorderStyle"
End Property

Public Sub AddLookup(Col As Integer, Value As String)
  Dim Item As New clsLookup
  Item.Column = Col
  Item.Value = Value
  m_LookupValues.Add Item
End Sub

Public Sub RemoveLookup(Col As Integer, Value As String)
  Dim cnt As Integer
  For cnt = 1 To m_LookupValues.Count
    If m_LookupValues(cnt).Value = Value And m_LookupValues(cnt).Column = Col Then
      m_LookupValues.Remove cnt
      Exit For
    End If
  Next
End Sub

Public Sub ClearLookup(Col As Integer)
  Dim cnt As Integer
  For cnt = 1 To m_LookupValues.Count
    If m_LookupValues(cnt).Column = Col Then
      m_LookupValues.Remove cnt
      cnt = 1
    End If
  Next
End Sub

Public Sub ClearAllLookups()
  Do Until m_LookupValues.Count = 0
    m_LookupValues.Remove 1
  Loop
End Sub

Public Function ColHasLookup(Col As Integer) As Boolean
  Dim cnt As Integer
  For cnt = 1 To m_LookupValues.Count
    If m_LookupValues(cnt).Column = Col Then
      ColHasLookup = True
      Exit Function
    End If
  Next
  ColHasLookup = False
End Function

Private Sub FillCombo(Col As Integer)
  Dim cnt As Integer
  List1.Clear
  For cnt = 1 To m_LookupValues.Count
    If m_LookupValues(cnt).Column = Col Then
      List1.AddItem m_LookupValues(cnt).Value
    End If
  Next
End Sub
